{$X+,B-,V-}
program GetCard;
{ USAGE: GetCard <cardnumber>
         (cardnumber in Uppercase characters.)

  Used within batch programs to check if the Node number of the current WS
  is equal to the number given by the cardnumber parameter. The WS doesn't
  need to be logged in, IPX is required.

  Returns result as errorlevel:
  0 = OK; the cardnumbers match.
  1 = Error; the cardnumbers DON'T match.
  2 = Error; one parameter (the cardnumber) must be supplied.
  3 = Error; IPX not loaded.                                             }

{ idea and c-sources: John Vanderaart,
                      LAN Magazine (NL), October 1992.                   }
Uses nwMisc,nwIPX;

Var addr:TInterNetWorkAddress;
    ParamAddr,FoundAddr:String;
    t:byte;

begin
Writeln('LanMagazine Utilities: GetCard');
Writeln;

If IpxInitialize
 then writeln('IPX init ok')
 else begin
      writeln('IPX init NOT ok');
      halt(3);
      end;

IPXGetInternetworkAddress(addr);

write('Network adress:');
for t:=1 to 4 do write(HexStr(addr.Net[t],2));
writeln;

FoundAddr:='';
for t:=1 to 6 do FoundAddr:=FoundAddr+HexStr(addr.Node[t],2);
writeln('Node: ',FoundAddr);

writeln(' Card NodeNumber:',FoundAddr);
If ParamCount=0
 then begin
      Writeln(' NetCard requires a parameter.');
      Halt(2) { no parameter supplied }
      end
 else ParamAddr:=ParamStr(1);

writeln(' Argument       :',ParamAddr);

if FoundAddr=ParamAddr
 then begin
      Writeln(' Result: OK');
      Halt(0);
      end
 else begin
      Writeln(' Result: NodeNumbers NOT Equal.');
      Halt(1);
      end
end.