UNIT NWintr;

{ NwTP Version 05, Copyright 1993,1994 R. Spronk }

{ This unit will be extended with protected mode versions of the
  RealModeIntr and F2SystemCall functions. Other functions will be added
  to support translation from real mode seg:ofs addresses to protected
  mode sel:ofs pointers. }

INTERFACE

{$IFDEF VER70}
{$A+,B-,D-,E-,F+,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$ELSE} { version 6.0 }
{$A+,B-,D-,E-,F+,G-,I-,L-,N-,O-,R-,S-,V-,X+}
{$ENDIF}

{$DEFINE ProtMode}

{$IFDEF MSDOS}
{$E+,G-,O- }
{$DEFINE RealMode}
{$UNDEF ProtMode}
{$ENDIF}

uses Dos;

Type TTregisters= record
                  case Integer of
                  0: (AX, BX, CX, DX, BP, SI, DI, DS, ES, Flags: Word);
                  1: (AL, AH, BL, BH, CL, CH, DL, DH: Byte);
                  end;

     TPtrRec=record Ofs,Seg:word end;

     TintrBuffer=array[1..576] of byte;
     TPintrBuffer=^TintrBuffer;

Var GlobalReqBuf,GlobalReplyBuf:TPintrBuffer;

Function RealModeIntr(intNo:byte;Var regs:TTregisters):boolean;
Procedure F2SystemCall(subf:byte;req_size,rep_size:word;Var result:word);

IMPLEMENTATION {===========================================================}

{$IFDEF RealMode}

{ ---------- Real mode procedures ------------------------------------}

Function RealModeIntr(intNo:byte;Var regs:TTregisters):boolean;
begin
Intr(intNo,registers(regs));
RealModeIntr:=true;
end;

Procedure F2SystemCall(subf:byte;req_size,rep_size:word;Var result:word);
Var regs:registers;
begin
With Regs
 do begin
    DS := TptrRec(GlobalReqBuf).seg;
    SI := TptrRec(GlobalReqBuf).ofs;   CX := Req_size;
    ES := TptrRec(GlobalReplyBuf).seg;
    DI := TptrRec(GlobalReplyBuf).ofs; DX := rep_size;
    AH := $F2; AL := subf;
    MSDOS(Regs);
    result:=al;
    end;
end;
{$ENDIF}

{$IFDEF ProtMode}
Function RealModeIntr(intNo:byte;Var regs:TTregisters):boolean;
 asm
 Sorry, no protected mode calls in version 0.5
 end;
{$ENDIF}

Var OldExitProc:pointer;

{$F+}
Procedure IntrExit;
begin
ExitProc:=OldExitProc;
{$IFDEF RealMode}
FreeMem(GlobalReqBuf,SizeOf(TintrBuffer));
Freemem(GlobalReplyBuf,Sizeof(TintrBuffer));
{$ENDIF}
end;
{$F-}


begin
{$IFDEF RealMode}
GetMem(GlobalReqBuf,SizeOf(TintrBuffer));
GetMem(GlobalReplyBuf,SizeOf(TintrBuffer));
{$ENDIF}
OldExitProc:=ExitProc;
ExitProc:=@IntrExit;
end.