{$IFDEF VER70}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,P+,Q-,R-,S-,T-,V-,X+}
{$ELSE}
{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X+}
{$ENDIF}
{$X+,B-,V-} {essential compiler directives}
{$IFDEF DEBUG}
{$D+,L+,Y+  Enable debug information }
{$ENDIF}

UNIT nwServ;

{ nwServ unit as of 940601 / NwTP 0.5 API. (c) 1993,1994, R.Spronk }

INTERFACE

uses nwIntr,NwMisc,nwConn;

Var result:word;

{ Primary Functions:                      Interrupt: Comments:

* CheckConsolePrivileges                  (F217/C8)
* ClearConnectionNumber                   (F217/D2)
* DisableFileServerLogin                  (F217/CB)
  DisableTransactionTracking              (F217/CF)
* DownFileServer                          (F217/D3)
* EnableFileServerLogin                   (F217/CC)
  EnableTransactionTracking               (F217/D0)
  GetConnectionsOpenFiles                 (F217/DB)
* GetDiskUtilization                      (F217/0E)
* GetFileServerDateAndTime                (F214)
* GetFileServerDescriptionStrings         (F217/C9)
* GetFileserverLoginStatus                (F217/CD)
* GetNetworkSerialNumber                  (F217/12)
* GetServerInformation                    (F217/11)
* SetFileServerDateAndTime                (F217/CA)
* VerifyNetworkSerialNumber               (F217/0C)

  Secondary functions:

* CheckNetwareVersion

  Not supported by netware 3.x: (2.x only)

- GetBinderyObjectDiskSpaceLeft           (F217/E6) (failed during testing)
- GetConnectionsTaskInformation           (E3../DA)
- GetConnectionsUsageStats                (E3../E5)
- GetConnectionsUsingAFile                (E3../DC)
- GetDiskCacheStats                       (E3../D6)
- GetDiskChannelStats                     (E3../D9)
- GetDriveMappingTable                    (E3../D7)
- GetFileServerLANIOStats                 (E3../E7)
- GetFileServerMiscInformation            (E3../E8)
- GetFileSystemStats                      (E3../D4)
- GetLANDriverConfigInfo                  (E3../E3)
- GetLogicalRecordInformation             (E3../E0)
- GetLogicalRecordsByConnection           (E3../DF)
- GetPhysicalDiskStats                    (E3../D8)
- GetPhysicalRecordLocksByFile            (E3../DE)
- GetPhysRecLocksByConnectAndFile         (E3../DD)
}


Type TserverInfo=Record
                ServerName         : string[48];
                NetwareVersion     : Byte;
                NetwareSubVersion  : Byte; { 0..99 }
                ConnectionsMax     : word;
                ConnectionsInUse   : word;
                MaxConnVol         : word; { max connected volumes }
                {---Advanced Netware 2.1x/3.x------------}
                OS_revision        : byte;
                SFT_level          : byte;
                TTS_level          : byte;
                peak_conn_used     : word; { max simult.used connections}
                accounting_version : byte;
                vap_version        : byte;
                queuing_version               : byte;
                print_server_version          : byte;
                virtual_console_version       : byte;
                security_restrictions_level   : byte;
                Internetwork_bridge_version   : byte;
                Undefined                     : Array [1..60] of Byte;
                End;

Type TfileInfoRecord=record
                     taskNbr:Byte;
                     lockFlag:Byte;
                     AccessFlag:Byte;
                     LockType:Byte; { 00 no lock; FE file lock; FF locked by Begin Share File Set }
                     volumeNbr:Byte; { 0..31 }
                     DirEntry:Word;
                     FileName:string[13];
                     end;

{Bitfields for lock flags:
 bit 0	file is locked
 bit 1	file opened Shareable
 bit 2	logged
 bit 3	file opened Normal
 bit 6	TTS holding lock
 bit 7	Transaction Flag set on file

Bitfields for access flags:
 bit 0	file open for reading by calling station
 bit 1	file open for writing by calling station
 bit 2	deny reads by other stations
 bit 3	deny writes by other stations
 bit 4	file detached
 bit 5	TTS Holding Detach
 bit 6	TTS Holding Open}



{F217/C8 [2.15c+]}
FUNCTION CheckConsolePrivileges : Boolean;

{F217/D2 [2.15c+]}
Function ClearConnectionNumber(connectionNbr:byte):boolean;
{ Console Rights needed;
  -Terminates a connection. }

{F217/CB [2.15c+]}
FUNCTION DisableFileServerLogin : Boolean;

{F217/CF [2.15c+]}
FUNCTION DisableTransactionTracking : Boolean;

{F217/D3 [2.15c+]}
FUNCTION DownFileServer (ForceFlag : Boolean) : Boolean;

{F217/CC [2.15c+]}
FUNCTION EnableFileServerLogin : Boolean;

{F217/D0 [2.15c+]}
FUNCTION EnableTransactionTracking : Boolean;


{F217/DB [2.15c+]}
FUNCTION GetConnectionsOpenFiles
           ( ConnID,ConnNumber  : Byte;
     {i/o:}  var LastRecordSeen : word;
     {out:}  var FileInfo: TfileInfoRecord ) : Boolean;

{F217/0E [2.15c+]}
FUNCTION GetDiskUtilization(volNbr:byte; objID:Longint;
                        Var usedDirs,usedFiles,usedBlocks:Word ):Boolean;

{F214    [2.15c+]}
FUNCTION GetFileServerDateAndTime ( Var time:TnovTime): Boolean;

{F217/C9 [2.15c+]}
FUNCTION GetFileServerDescriptionStrings(Var companyName,
                                             VersionAndRevision,revisionDate,
                                             copyrightNotice:String
                                         ):Boolean;

{F217/CD [2.15c+]}
FUNCTION GetFileServerLoginStatus (Var LoginEnabled:Boolean): Boolean;
{ if Login is enabled then returns TRUE in LoginEnabled }

{F217/12 [2.15c+]}
Function GetNetworkSerialNumber(Var serialNbr:LongInt; Var ApplicNbr:Word ):Boolean;
{return the serial number and application number for the software
	  installed on the file server}

{F217/11 [2.15c+]}
Function GetServerInformation (Var serverInfo:TserverInfo):boolean;
{determine the version of software installed on the file server and how it is configured}

{F217/CA [2.15c+]}
FUNCTION SetFileServerDateAndTime(time:TnovTime):Boolean;
{need console operator privileges to do this}

{F217/OC [2.15c+]}
Function VerifyNetworkSerialNumber(serialNbr: LongInt ;
                               Var ApplicNbr: Word     ):Boolean;
{if the network serial number to be verified is correct, the reply
	  buffer will contain the corresponding application number }

{*********************** Secondary Functions ******************************}

{ [1.x/2.x/3.x] }
FUNCTION CheckNetwareVersion(MinimumVersion,MinimumSubVersion,
                             MinimumRevision,MinimumSFT,MinimumTTS:word):Boolean;

Function GetEtherNetManufacturer(addr:TNodeAddress):string;
{ Returns the name of the manufacturer of the ethernetcard, with the aid
  of the first 3 bytes of the nodeaddress. This address can be obtained
  by the IPXGetInternetworkAddress function.                            }

IMPLEMENTATION{=============================================================}


{F217/D2 [2.15c+]}
Function ClearConnectionNumber(connectionNbr:byte):boolean;
{ Console Rights needed;
  -Terminates a connection. }
Type Treq=record
          len : word;
          subf: byte;
          _connNbr:byte;
          end;
     TPreq=^Treq;
begin
With TPreq(GlobalReqBuf)^
do begin
   len:=2;
   subf:=$D2;
   _connNbr:=connectionNbr
   end;
F2SystemCall($17,SizeOf(Treq),0,result);
ClearConnectionNumber:=(result=0);
{result codes: 00 successful; C6 No Console Rights}
end;

{F214 [2.15c+]}
FUNCTION GetFileServerDateAndTime ( Var time:TnovTime): Boolean;
Type Trep=TnovTime;
     TPrep=^Trep;
BEGIN
F2SystemCall($14,0,SizeOf(Trep),result);
Time:=TPrep(GlobalreplyBuf)^;
if time.year>100
 then time.year:=time.year-100;
{ year<80 : 21st century }
result:=0;
getFileServerDateAndTime:=TRUE;
end;


{F217/CA [2.15c+]}
FUNCTION SetFileServerDateAndTime (time:TnovTime): Boolean;
Type Treq=record
          Len:word;
          subF:byte;
          _time:TnovTime
          end;
     TPreq=^Treq;
BEGIN
{ year<80 : 21st century }
WITH TPreq(GlobalReqBuf)^
do begin
   Len:=SizeOf(Treq)-3; { dow is not a parameter }
   subF:=$CA;
   _time:=time;
   end;
F2SystemCall($17,SizeOf(Treq),0,result);
SetFileServerDateAndTime:=(Result=$00);
{ Resulcodes: $00 Success; $C6 No Console Operator Rights }
end;


{F217/11 [2.15c+]}
Function GetServerInformation (Var serverInfo:TserverInfo):boolean;
{determine the version of software installed on the file server and how it is configured}

{SeeAlso: GetDiskUtilization, GetNetworkSerialNumber, GetFileServerLoginStatus,
          GetFileServerDateAndTime}

Type TReq=Record
          Len  : word;
          SubF : Byte;
          End;
     TRep=TserverInfo;
     TPreq=^Treq;
     TPrep=^Trep;

Var t:word;
Begin
With TPreq(GlobalReqBuf)^
Do Begin
   Len := 1;
   SubF:= $11;
   End;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep)-1,result);
Move(GlobalReplyBuf^[1],GlobalReplyBuf^[2],SizeOf(Trep)-1);
serverInfo:=TPrep(GlobalReplyBuf)^;
With serverinfo
do begin
   connectionsMax  :=Swap(connectionsMax);   { force lo-hi again }
   ConnectionsInUse:=Swap(connectionsInUse);
   MaxConnVol      :=Swap(maxConnVol);
   peak_conn_used  :=Swap(peak_conn_used);
   for t:=48 downto 1
    do if serverInfo.serverName[t]=#0
        then serverInfo.serverName[0]:=chr(t-1);
   end;
GetServerInformation:=(result=0);
End;



{F217/C9 [2.15c+]}
FUNCTION GetFileServerDescriptionStrings(Var companyName,
                                             VersionAndRevision,revisionDate,
                                             copyrightNotice:String
                                         ):Boolean;
{SeeAlso: GetFileServerLoginStatus, GetServerInformation. }
Type Treq=record
          len : word;
          subf: byte;
          end;
     Trep=record
          stuff : array [1..512] of byte;
          end;
     TPreq=^Treq;
     TPrep=^Trep;
Var x,xofs:word;
begin
With TPreq(GlobalReqBuf)^
do begin
   len  := 1;
   subf := $c9;
   end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
companyName:=''; VersionAndRevision:='';
revisionDate:=''; copyrightNotice:='';
if result=$00
 then with TPrep(GlobalReplyBuf)^
      do begin
         x:=1;xofs:=x;
         while (stuff[x]<>$00) and (x<512) do inc(x);
         ZStrCopy(companyName,stuff[xofs],x-xofs);

         inc(x);xofs:=x; { skip 1 zero. ? skip more zero's? }
         While (stuff[x]<>$00) and (x<512) do inc(x);
         ZStrCopy(VersionAndRevision,stuff[xofs],x-xofs);

         inc(x);xofs:=x;
         While (stuff[x]<>$00) and (x<512) do inc(x);
         ZStrCopy(revisionDate,stuff[xofs],x-xofs); { mm/dd/yy }

         inc(x);xofs:=x;
         While (stuff[x]<>$00) and (x<512) do inc(x);
         ZStrCopy(copyrightNotice,stuff[xofs],x-xofs);
         end;
GetFileServerDescriptionStrings:=(Result=$00);
end;



{F217/D3 [2.15c+]}
FUNCTION DownFileServer (ForceFlag : Boolean) : Boolean;
Type Treq=record
          len  : word;
          subf : byte;
          flag : byte;
          end;
     TPreq=^Treq;
BEGIN
With TPreq(GlobalReqBuf)^
do begin
   len  := 2;
   subf := $D3;
   if ForceFlag then flag := $FF { non-zero }
                else flag := $00;
   end;
F2SystemCall($17,SizeOf(Treq),0,result);
DownFileServer:=(result=0);
{ resultcodes: 00=successful; C6 No Console Rights ; FF Open Files}
end;


{F217/CF [3.x]}
FUNCTION DisableTransactionTracking : Boolean;
{ Caller must have console-operator rights. }
Type Treq=record
          len : word;
          subf: byte
          end;
     TPreq=^Treq;
BEGIN
With TPreq(GlobalReqBuf)^
 do begin
    len := 1;
    subf:= $CF;
    end;
F2SystemCall($17,SizeOf(Treq),0,result);
DisableTransactionTracking:=(result=0);
{ resultcodes: 00=successful; C6 No Console Rights }
end;


{F217/D0 [3.x]}
FUNCTION EnableTransactionTracking : Boolean;
{ Caller must have console-operator rights. }
Type Treq=record
          len : word;
          subf: byte
          end;
     TPreq=^Treq;
BEGIN
With TPreq(GlobalReqBuf)^
 do begin
    len := 1;
    subf:= $D0;
    end;
F2SystemCall($17,SizeOf(Treq),0,result);
EnableTransactionTracking:=(result=0);
{ resultcodes: 00=successful; C6 No Console Rights }
end;


{F217/CB [2.15c+]}
FUNCTION DisableFileServerLogin : Boolean;
{ Caller must have console-operator rights. }
Type Treq=record
          len : word;
          subf: byte
          end;
     TPreq=^Treq;
BEGIN
With TPreq(GlobalReqBuf)^
 do begin
    len := 1;
    subf:= $CB;
    end;
F2SystemCall($17,SizeOf(Treq),0,result);
DisableFileServerLogin:=(result=0);
{ resultcodes: 00=successful; C6 No Console Rights }
end;



{F217/CC [2.15c+]}
FUNCTION EnableFileServerLogin : Boolean;
{ Caller needs console-operator rights. }
Type Treq=record
          len : word;
          subf: byte
          end;
     TPreq=^Treq;
BEGIN
With TPreq(GlobalReqBuf)^
 do begin
    len := 1;
    subf:= $CC;
    end;
F2SystemCall($17,SizeOf(Treq),0,result);
EnableFileServerLogin:=(result=0);
{ resultcodes: 00=successful; C6 No Console Rights }
end;



{F217/CD [2.15c+]}
FUNCTION GetFileServerLoginStatus( Var LoginEnabled:Boolean ): Boolean;
{ if Login is enabled then returns TRUE in LoginEnabled }
{ result byte:  00h  - Success, C6h No Console Rights }
{ Caller must have operator status.}
Type TReq=record
          Len     : Word;
          SubF    : Byte;
          end;
     TRep=record
          Flag    : Byte;
          end;
     TPreq=^Treq;
     TPrep=^Trep;
begin
with TPreq(GlobalReqBuf)^
 do begin
    Len     := 1;
    SubF    := $CD;
    end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
LoginEnabled:=Boolean(TPrep(GlobalReplyBuf)^.Flag);
GetFileServerLoginStatus := (result=0);
end;


{F217/C8 [2.15c+]}
FUNCTION CheckConsolePrivileges : Boolean;
Type TReq=record
          Len  : Word;
          SubF : Byte;
          end;
     TPreq=^Treq;
begin
with TPReq(GlobalReqBuf)^
 do begin
    Len  := 1;
    SubF := $C8;
    end;
F2SystemCall($17,SizeOf(Treq),0,result);
CheckConsolePrivileges := (Result=$00);
{ result byte:  00h  - Success, C6h No Console Rights }
end;


{F217/DB [2.15c+]}
FUNCTION GetConnectionsOpenFiles
           ( ConnID,ConnNumber  : Byte;
     {i/o:}  var LastRecordSeen : word;
     {out:}  var FileInfo: TfileInfoRecord ) : Boolean;

{ the calling workstation must have console operator privileges }
{ LastRecordSeen is an i/o parameter;
  -An initial value of 0 has to be supplied;
  -The function can be called until LastRecordSeen becomes 0,
   indicating the end of the FIR-list.

  to be called iteratively. }

Type Barr=array[1..14] of byte;
     TReq=record
          len:word;
          subf:byte;
          logicalConnNbr:word; {hi-lo}
          lastRecSeen:word; {hi-lo, $0000 on first call }
          end;
     TRep=record
          nextReqRec : word; { hi-lo, use as lastRecSeen in next iterative call }
                             { $0000 if no more records }
          RecCount   : byte;
          FileInfoRec: TfileInfoRecord;
          fill:array[1..10] of byte;
          end;
     TPreq=^Treq;
     TPrep=^Trep;
Var resConnID:Byte;

{ normally a great number of File Information Records can be returned by one call.
  We have changed the function so that it returns one FIR per call. }

begin
{ !! set server with connID as preferred server !  }
GetPreferredConnectionID(resConnID);
SetPreferredConnectionID(connID);

With TPreq(GlobalReqBuf)^
 do begin
    len:=sizeof(Treq)-2;
    subf:=$DB;
    logicalConnNbr:=swap(connNumber); { force hi-lo }
    lastRecSeen:=swap(LastRecordSeen); { force hi-lo }
    end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
if result=$00
 then with TPrep(GlobalReplyBuf)^
      do begin
         if recCount<>1
          then result:=$101
          else begin
               LastRecordSeen:=swap(NextReqRec); { force lo-hi }
               FileInfo:=FileInfoRec;
               fileinfo.DirEntry:=swap(fileinfo.DirEntry); { force lo-hi again }
               ZstrCopy(fileInfo.filename,Barr(FileInfoRec.filename),14);
               end;
     end;

{ !! reset old preferred server ! }
SetPreferredConnectionID(resConnID);

GetConnectionsOpenFiles:=(result=$00);
{ errorcodes: $00 Success; $C6 no console privileges }
end;


{F217/0E [2.15c+]}
FUNCTION GetDiskUtilization(volNbr:byte; objID:Longint;
                        Var usedDirs,usedFiles,usedBlocks:Word ):Boolean;
{ SeeAlso: GetServerInformation,getBinderyObjectDiskSpaceLeft }
Type TReq=record
          Len  : Word;
          SubF : Byte;
          _volNbr:Byte;
          _objID:longInt; { hi-lo }
          end;
     TRep=record
          _volNbr:Byte;
          _objID:Longint; {hi-lo}
          _usedDirs,
          _usedFiles,
          _usedBlocks:Word; { all hi-lo }
          end;
    TPreq=^Treq;
    TPrep=^Trep;
begin
with TPReq(GlobalReqBuf)^
 do begin
    Len  := SizeOf(TReq)-2;
    SubF := $0E;
    _volNbr:=volNbr;
    _objID:=Lswap(objID);
    end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
if result=$00
then begin
     with TPrep(GlobalReplyBuf)^
     do begin
        usedDirs:=swap(_usedDirs);    { force lo-hi }
        usedFiles:=swap(_usedFiles);  { force lo-hi }
        usedBlocks:=swap(_usedBlocks);{ force lo-hi }
        end;
     end;
GetDiskUtilization:=(result=$00);
{Resultcodes: 00h successful; 98h volume doesn't exist
              89h No Search Privileges
   	      F2h no Object read privileges }
end;


{F217/12 [2.15c+]}
Function GetNetworkSerialNumber(Var serialNbr:LongInt; Var ApplicNbr:Word ):Boolean;
{return the serial number and application number for the software
	  installed on the file server}
{SeeAlso: VerifyNetworkSerialNumber,GetServerInformation}
Type TReq=record
          Len     : Word;
          SubF    : Byte;
          end;
     TRep=record
          _serNbr   : LongInt; {hi-lo}
          _applicNbr: Word;    {hi-lo}
          end;
     TPreq=^Treq;
     TPrep=^Trep;
begin
with TPreq(GlobalReqBuf)^
 do begin
    Len     := 1;
    SubF    := $12;
    end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
with TPrep(GlobalReplyBuf)^
 do begin
    ApplicNbr:=swap(_applicNbr);   { force lo-hi }
    serialNbr:=Lswap(_serNbr);     { force lo-hi }
    end;
GetNetworkSerialNumber := (result=0);
end;



{F217/OC [2.15c+]}
Function VerifyNetworkSerialNumber(serialNbr: LongInt ;
                               Var ApplicNbr: Word     ):Boolean;
{if the network serial number to be verified is correct, the reply
	  buffer will contain the corresponding application number }
{SeeAlso: GetNetworkSerialNumber}
Type Treq=record
          Len        : Word;
          SubF       : Byte;
          _netwSerNbr: LongInt; {hi-lo}
          end;
     TRep=record
          _applicNbr: word; {hi-lo}
          end;
     TPreq=^Treq;
     TPrep=^Trep;
begin
with TPReq(GlobalReqBuf)^
 do begin
    Len     := 1;
    SubF    := $0C;
    _netwSerNbr:=Lswap(serialNbr);
    end;
F2SystemCall($17,SizeOf(Treq),SizeOf(Trep),result);
with TPrep(GlobalReplyBuf)^
do begin
   ApplicNbr:=swap(_applicNbr); { force lo-hi }
   end;
VerifyNetworkSerialNumber := (result=0);
end;


{****************** secondary functions ************************************}


FUNCTION CheckNetwareVersion(MinimumVersion,MinimumSubVersion,
                             MinimumRevision,MinimumSFT,MinimumTTS:word):Boolean;
{ checks if the current OS/TTS/SFT version is greater or equal to the minimal version }
Var info:TserverInfo;
    res:boolean;
begin
IF GetServerInformation(info)
then begin
     IF (info.NetwareVersion>MinimumVersion)
       then res:=true
       else if (info.NetwareVersion=MinimumVersion)
               AND (info.NetwareSubVersion>MinimumSubVersion)
            then res:=true
            else if (info.NetwareVersion=MinimumVersion)
                    AND (info.NetwareSubVersion=MinimumSubVersion)
                    AND (info.OS_Revision>=MinimumRevision)
                 then res:=true
                 else res:=false
     end
else res:=false;

CheckNetwareVersion:=res AND (info.SFT_Level>=MinimumSFT)
                         AND (info.TTS_Level>=MinimumTTS)
end;


Function GetEtherNetManufacturer(addr:TNodeAddress):string;
{ Returns the name of the manufacturer of the ethernetcard, with the aid
  of the first 3 bytes of the nodeaddress. This address can be obtained
  by the IPXGetInternetworkAddress function.                            }
Var res:string;
    cnum:LongInt;
    t:byte;
    Procedure BitReverse(Var b:Byte);
    Var x:Byte;
    begin
    x:=0;
    if (b and $80)>0 then x:=(x or $01);
    if (b and $40)>0 then x:=(x or $02);
    if (b and $20)>0 then x:=(x or $04);
    if (b and $10)>0 then x:=(x or $08);
    if (b and $08)>0 then x:=(x or $10);
    if (b and $04)>0 then x:=(x or $20);
    if (b and $02)>0 then x:=(x or $40);
    if (b and $01)>0 then x:=(x or $80);
    b:=x;
    end;
begin
{ Checked with the vendors list supplied with Ethload 1.04 }
res:='';
cnum:=$00000000;
for t:=3 downto 1
 do begin
    cnum:=cnum SHL 8;
    cnum:=cnum+addr[t];
    end;
if cnum<$080000
then begin
     if cnum<$FF
     then begin {000000..0000FF}
          case lo(cnum) Of
          $02:res:='BBN';
          $0C:res:='Cisco';
          $0E:res:='Fujitsu';
          $0F:res:='NeXT';
          $10:res:='Sytek/Hughes LAN Systems';
          $11:res:='Tektronics';
          $15:res:='Datapoint';
          $18:res:='Webster';
          $1A:res:='AMD ?';
          $1B:res:='Novell/Eagle Technology';
          $1D:res:='Cabletron';
          $20:res:='DIAB (Data Industrier AB)';
          $21:res:='SC&C';
          $22:res:='Visual Technology (Vistec)';
          $23:res:='ABB';
          $29:res:='IMC';
          $2A:res:='TRW';
          $3C:res:='Auspex';
          $3D:res:='ATT';
          $44:res:='Castelle';
          $46:res:='Bunker Ramo';
          $49:res:='Apricot';
          $4B:res:='APT';
          $4F:res:='Logicraft';
          $51:res:='Hob Electronic';
          $52:res:='ODS';
          $55:res:='AT&T';
          $5A:res:='SK/Xerox';
          $5D:res:='RCE';
          $5E:res:='IANA';
          $61:res:='Gateway';
          $62:res:='Homeywell';
          $65:res:='Network General';
          $69:res:='Silicon Graphics';
          $6B:res:='MIPS';
          $6E:res:='Artisoft';
          $77:res:='MIPS/Interphase';
          $78:res:='Labtam';
          $7A:res:='Ardent';
          $7B:res:='Research Machines';
          $7D:res:='Cray Research/Harris';
          $7F:res:='Linotronic';
          $80:res:='Dowty Network Services (/Harris?)';
          $81:res:='SynOptics';
          $84:res:='Aquila ?';
          $86:res:='Gateway';
          $89:res:='Cayman Systems';
          $8A:res:='Datahouse Information Systems';
          $8E:res:='Jupiter ? Solbourne ?';
          $93:res:='Proteon';
          $94:res:='Asante';
          $95:res:='Sony/Tektronics';
          $97:res:='Epoch';
          $98:res:='CrossCom';
          $9F:res:='Ameristar Technology';
          $A0:res:='Sanyo Electronics';
          $A2:res:='Wellfleet Communications';
          $A3:res:='NAT';
          $A4:res:='Acorn';
          $A5:res:='Compatible Systems Corporation';
          $A6:res:='Network General';
          $A7:res:='NCD';
          $A8:res:='Stratus';
          $A9:res:='Network systems';
          $AA:res:='Xerox';
          $B3:res:='Cimlin';
          $B7:res:='Dove';
          $C0:res:='Western Digital/SMC';
          $C6:res:='Hewlett-Packard Co./Eon';
          $C9:res:='Emulex';
          $D8:res:='3Com? Novell? PS/2';
          $DD:res:='Gould';
          $E2:res:='Acer';
          $EF:res:='Alantc';
          end {case}
          end
     else begin {0000FF..07FFFF}
          if      cnum=$000102 then res:='BBN'
          else if cnum=$00082D then res:='Siemens Nixdorf: TACLAN ?'
          else if cnum=$00608C then res:='3Com ?'
          else if cnum=$00805C then res:='Agilis'  { correct? see $08005C }
          else if cnum=$00AA00 then res:='Intel Corp.'
          else if cnum=$00DD00 then res:='Ungermann-Bass'
          else if cnum=$00DD01 then res:='Ungermann-Bass'
          else if cnum=$020701 then res:='MICOM/Interlan'
          else if cnum=$02608C then res:='3Com Corp.'
          else if cnum=$02CF1F then res:='CMC'
          end
     end
else begin
     if cnum<$0800FF
     then begin   {080000 .. 0800FF}
          CASE lo(cnum) OF
          $01:res:='CmpVsn';
          $02:res:='3COM-Bridge';
          $03:res:='ACC';
          $05:res:='Symbolics';
          $06:res:='Siemens-Nixdorf';
          $07:res:='Apple';
          $08:res:='BBN';
          $09:res:='Hewlett-Packard Co.';
          $0A:res:='Nestar Systems';
          $0B:res:='Unisys';
          $10:res:='AT&T';
          $11:res:='Tektronics';
          $14:res:='ExceLan';
          $17:res:='NSC';
          $1A:res:='DG';
          $1B:res:='DG';
          $1E:res:='Apollo';
          $20:res:='SUN Microsystems';
          $22:res:='NBI';
          $25:res:='CDC';
          $28:res:='Texas Instruments';
          $2B:res:='Digital Equipment Corp. (DEC)';
          $2E:res:='Metaphor';
          $36:res:='Intergraph';
          $38:res:='Bull';
          $39:res:='Spider';
          $41:res:='DCA';
          $45:res:='Xylogic';
          $46:res:='Sony';
          $47:res:='Sequnt';
          $49:res:='Univtn';
          $4C:res:='Encore';
          $4E:res:='BICC';
          $5A:res:='IBM Corp.';
          $5C:res:='Agilis ?'; { seems more likely than $00805C }
          $67:res:='ComDes';
          $68:res:='Ridge';
          $69:res:='Silicon Grafics';
          $6A:res:='AT&T';
          $6E:res:='ExceLan';
          $75:res:='DDE';
          $7C:res:='Vitalink';
          $87:res:='Xyplex';
          $89:res:='Kinetics';
          $8B:res:='Pyramid';
          $8D:res:='Xyvision';
          $90:res:='Retix';
          end; {case}
          end
     else begin {0800FF..FFFFFF}
          if      cnum=$AA0000 then res:='DEC (obsolete nbr) [Multicast]'
          else if cnum=$AA0001 then res:='DEC (obsolete nbr) [Multicast]'
          else if cnum=$AA0002 then res:='DEC (obsolete nbr) [Multicast]'
          else if cnum=$AA0003 then res:='Digital Equipment Corp. (DEC) [Multicast]'
          else if cnum=$AA0004 then res:='Logical DECnet address. (DEC) [Multicast]'
          else if cnum=$AA002C then res:='Intel ? [Multicast]';
          end;
     end;
if (res='') and (addr[1]>$10)
   and NOT((addr[4]=$FF) and (addr[5]=$FF) and (addr[6]=$FF))
 then begin
      FillChar(addr[4],3,#$FF);
      BitReverse(addr[1]);
      BitReverse(addr[2]);
      BitReverse(addr[3]);
      res:=GetEtherNetManuFacturer(addr);
      if res<>''
       then res:=res+' (MAC address converted by bridge)'
      end;
if res=''
 then res:='<Unknown manufacturer>';
GetEtherNetManuFacturer:=Res;
end;


end. {unit nwServ}