program Phone;

{ Based on the phone.pas program by Eduardo M. Serrat,
  as published bin Dr.Dobbs #207, November 1993.       }

{ This extended version is provided with the NwTP 0.5 }

uses dos,crt,nwMisc,nwConn,nwMess,nwIPX;

const Socket  = $80C3;
      { This socket was assigned by Novell to an IPX Chatprogram by OXXI }
      { Don't use this program in conjunction with theirs..              }
var
   SendECB,
   ListenECB        :  TEcb;                     { Definition of ECBs        }
   SendIpxHeader,
   ListenIPXheader:  TIpxHeader;               { Definition of IPX Headers }
   SendData,
   ReadData       :  array [1..5] of byte;    { Data area of packets      }

   ConnList       :  TConnectionList;         { Connection Number Struc   }

   LocalTarget    :  TnodeAddress;            { Node Address              }
   I              :  word;
   readflg        :  boolean;                 { Flag to signal received
                                                    packets                   }
   MyConnNbr:byte;
   MyAddress:TinternetworkAddress;
   MyName:String;
   MyServerId:Byte;

   RconnNbr:byte;
   Raddress             :  TinterNetworkAddress;
   Rname:String;
   RserverID:byte;

   myx,myy,rx,ry      :  byte;                    {  ViewPorts cursor position}

   NewStack:array[1..512] of word;   { !! used by ESR }
   StackBottom:word;                 { !! used by ESR }

{-----------------------------------------------------------------------------}

{$F+}
Procedure ESRproc;
begin
 ReadFlg:=true;
end;

Procedure ESRHandler; assembler;
asm { ES:SI are the only valid registers when entering this procedure ! }
    mov dx, seg stackbottom
    mov ds, dx

    mov dx,ss  { setup of a new local stack }
    mov bx,sp  { ss:sp copied to dx:bx}
    mov ax,ds
    mov ss,ax
    mov sp,offset stackbottom
    push dx
    push bx

    CALL EsrProc

    pop bx
    pop dx
    mov sp,bx
    mov ss,dx
end;
{$F-}

{-----------------------------------------------------------------------------}
procedure Send;
begin
Raddress.socket:=socket;
IPXSetupSendECB(NIL, Raddress, Addr(SendData), SizeOf(SendData),
                SendIPXheader,SendECB);
IpxSendPacket(SendECB);                                 { Send packet    }
end;
{-----------------------------------------------------------------------------}
procedure Listen;
begin
IPXSetupListenECB(Addr(EsrHandler),socket,Addr(ReadData),SizeOf(ReadData),
                  ListenIPXheader,ListenECB);
IpxListenForPacket(ListenECB);
end;
{-----------------------------------------------------------------------------}
function TestConnection : boolean;
var i : byte;
begin
TestConnection:=True;

{for i:=1 to 6 do
  begin
    if ListenIPXheader.Source.Node[i] <>
       SendIpxHeader.Destination.Node[i]
       then TestConnection:=FALSE;
  end;}
end;

{----------------------------------------------------------------------------}

function LeadingZero(w:word):string;
var s : String;
begin
Str(w:0,s);
if Length(s) = 1
 then s := '0' + s;
LeadingZero := s;
end;

function Time:string;
var h, m, s, hund : Word;
begin
GetTime(h,m,s,hund);
Time:=LeadingZero(h)+':'+LeadingZero(m)+':'+LeadingZero(s);
end;

{-----------------------------------------------------------------------------}
procedure HandShake;
const Progress  :  array [1..4] of char = ('/','','\','|');
var
   Cnt         :  integer;
   message     :  string;
   i           :  byte;
   x,y         :  byte;
   ptr, car    :  byte;
   h, m,s,hund :  Word;
   ConnUp      :  boolean;
   UserID      :  string;
   ObjName:string;
   ObjType:word;
   ObjId:LongInt;
   LogonTime:TnovTime;
   ResultList:TconnectionList;
begin
Writeln('Calling User ',Rname);
Write('Press <ESC> to cancel [ ]');
x:=wherex-2; y:=wherey;
Message:='User '+MyName+' is phoning you........... ['+Time+']';
Cnt:=0; Ptr:=1;

SendBroadcastMessage(message,1,ConnList,ResultList);

Listen;
car:=$ff;
ConnUp:=False;

repeat
  gotoxy(x,y);
  write(Progress[ptr]);
  inc(ptr);
  if ptr > 4
   then begin
        ptr:=1;
        SendData[1]:=MyConnNbr;
        Send;
        end;
  inc(Cnt);
  if Cnt = 30
   then begin
        SendBroadcastMessage(message,1,ConnList,ResultList);
        Cnt:=0;
        end;
  delay(1000);
  if readflg
   then begin
        writeln('recieved a packet..');
         if not TestConnection
          then begin
               readflg:=false;
               Listen;
               end
          else ConnUp:=TRUE;
        end;
  if keypressed
   then car:=ord(readkey);

until (car = $1b) or ConnUp;

if car = $1b
 then begin
      Writeln;
      Write('Wait...');
      Delay(5000);
      SendData[1]:=$1b;
      Send;
      message:='The user phoning you canceled the call... ['+Time+']';
      SendBroadcastMessage(message,1,ConnList,ResultList);
      IpxCloseSocket(Socket);
      SetPreferredConnectionID(MyServerId);
      halt(1);
      end;
Writeln;
Write('User ',Rname,' answered your call......!');
delay(1200);
ReadFlg:=false;
end;

{-----------------------------------------------------------------------------}
procedure MyWindow;
begin
Window(1,5,80,12);
gotoxy(myx,myy);
end;
{-----------------------------------------------------------------------------}
procedure RemoteWindow;
begin
Window(1,17,80,24);
gotoxy(rx,ry);
end;
{-----------------------------------------------------------------------------}
procedure InitWindows;
var
   i          :  integer;
begin
ClrScr;
myx:=1; myy:=1;
rx:=1;  ry:=1;
gotoxy(1,1);
write(''); for i:=2 to 79 do write(''); write('');
write(''); for i:=2 to 79 do write(' '); write('');
write(''); for i:=2 to 79 do write(''); write('');

gotoxy(3,2);
Write('User: '+MyName+'  Node: ');
for i:=1 to 6
 do begin
    Write(HexStr(MyAddress.Node[i],2));
    if i <> 6
     then write('.');
    end;
Write('  Net: ');
for i:=1 to 4
 do begin
    Write(HexStr(MyAddress.Net[i],2));
    if i <> 4
     then write ('.');
    end;
Write('  Connection: '); write(MyConnNbr);
gotoxy(1,13);
write(''); for i:=2 to 79 do write(''); write('');
write(''); for i:=2 to 79 do write(' '); write('');
write(''); for i:=2 to 79 do write(''); write('');

gotoxy(3,14);
Write('User: '+Rname+'  Node: ');
for i:=1 to 6
 do begin
    Write(HexStr(Raddress.Node[i],2));
    if i <> 6
     then write('.');
    end;
Write('  Net: ');
for i:=1 to 4
 do begin
    Write(HexStr(Raddress.Net[i],2));
    if i <> 4
     then write ('.');
    end;
Write('  Connection: '); write(RconnNbr);

gotoxy(26,25);
Write(' Phone Utility ');
gotoxy(1,1);
RemoteWindow;
MyWindow;
HighVideo;
end;
{-----------------------------------------------------------------------------}
procedure Talk;
begin
InitWindows;
Listen;
repeat
 if keypressed
  then begin
       MyWindow;
       SendData[1]:=ord(Readkey);
       if SendData[1]=13
        then writeln
        else write(chr(SendData[1]));
       myx:=wherex;
       myy:=wherey;
       send;
       end;
 if readflg
  then begin
       If TestConnection
        then begin
             RemoteWindow;
             if ReadData[1]=13
              then writeln
              else write(chr(ReadData[1]));
             rx:=wherex;
             ry:=wherey;
             end;
       readflg:=false;
       Listen;
       end;
until (ReadData[1]=$1b) or (SendData[1]=$1b);
SendData[1]:=$1b; send;
IpxCloseSocket(Socket);
Writeln; Writeln;
writeln('<Hanging Up...........>');
Delay(3000);
Window(1,1,80,25);
LowVideo;
gotoxy(80,25);
end;

{-----------------------------------------------------------------------------}
procedure CallUser;
Var ticks:word;
begin
GetInternetAddress(RconnNbr,Raddress);
IPXGetLocalTarget(Raddress,LocalTarget,ticks);

HandShake;
Talk;
end;
{-----------------------------------------------------------------------------}

procedure ProcessInputCommand;
var ConNbr  :  byte;
    Code    :  integer;
    i       :  integer;
    ticks:word;
    NbrOfCon:byte;
    p:byte;
    RserverName:string;

    ObjType:word;
    ObjId:LongInt;
    LogonTime:TnovTime;

    Procedure AbortPhone;
    begin
    IpxCloseSocket(Socket);
    SetPreferredConnectionId(MyServerId);
    halt(1);
    end;

begin
IF ParamCount>0
 then begin
      Rname:=paramstr(1);
      UpString(Rname);
      p:=pos('\',Rname);
      if p>0
       then begin
            RServerName:=copy(Rname,1,p-1);
            delete(Rname,1,p);
            { !!!!!!! }
            { SetPreferredConnectionId(  )}
            end
       else RserverId:=MyServerId;
      end;
Case ParamCount of
  0  : begin
       Listen;
       p:=0;
       while(p<24) and (not ReadFlg)
        do begin
           delay(250);
           inc(p);
           end;
       If not readflg
        then begin
             Writeln;
             Writeln('Nobody is Calling you..........');
             AbortPhone;
             end
       else  begin
             readflg:=false;
             Raddress:=ListenIPXheader.source;
             Raddress.socket:=Socket;
             RconnNbr:=ReadData[1];
             {!!!! IF Radddress.net<>MyAddress.net then SetPreferredserverID() }
             GetConnectionInformation(RConnNbr,RName,ObjType,ObjId,LogonTime);
             IPXGetLocalTarget(Raddress,LocalTarget,ticks);
             SendData[1]:=MyConnNbr;
             Send;
             Talk;
             end;
       end;

  1  : begin
       GetObjectConnectionNumbers(Rname,$0001,
                                  NbrOfCon,ConnList);
       if NbrOfCon = 0
        then begin
             {!!!! username not on effective server.
                   try all servers we're attached to..}

             Writeln;
             Writeln('User ID not available......');
             AbortPhone;
             end;
       if (NbrOfCon = 1) and (ConnList[1] = MyConnNbr)
        then begin
             Writeln;
             Writeln('Phoning YourSelf ????');
             AbortPhone;
             end;
       if NbrOfCon = 1
        then begin
             RconnNbr:=ConnList[1];
             CallUser
             end
        else begin
             Writeln;
             Writeln('User ',Paramstr(1),' has multiple sessions');
             Writeln('Please specify Connection Number..........');
             AbortPhone;
             end;
       end;
  2  : begin
       val(paramstr(2),ConNbr,Code);
       if code <> 0
        then begin
             Writeln;
             Writeln('Invalid Connection Number Entered.....');
             AbortPhone;
             end;
       GetObjectConnectionNumbers(Rname,$0001,
                                  NbrOfCon,ConnList);
       if NbrOfCon = 0
        then begin
             {!!! check other servers we're attached to for this user ID}

             Writeln;
             Writeln('User ID not available......');
             AbortPhone;
             end;
       for code:=1 to NbrOfCon
        do begin
           if ConnList[code] = ConNbr
            then ConnList[1]:=ConNbr;
           end;
       if (ConnList[1] =  MyConnNbr)
        then begin
             Writeln;
             Writeln('Phoning YourSelf ????');
             AbortPhone;
             end;
       if ConnList[1] = ConNbr
        then CallUser
        else begin
             Writeln;
             Writeln('Connection: ',paramstr(2),' doesn''t exist');
             AbortPhone;
             end;
       end;
  else
       begin
       Writeln;
       Writeln;
       Writeln('Phone Utility Command Syntax: ');
       Writeln;
       Writeln('Phone [[[Server Name\]UserId] [Connection Number]]');
       AbortPhone;
       end;
end; {Case}
end;

Procedure WhoAmI; {---------------------------------------------------------}
Var ObjType:word;
    ObjId:LongInt;
    LogonTime:TnovTime;
begin
GetConnectionNumber(MyConnNbr);
GetInternetAddress(MyConnNbr,MyAddress);
MyAddress.Socket:=Socket;
GetConnectionInformation(MyConnNbr,MyName,ObjType,ObjId,LogonTime);
GetPreferredConnectionID(MyServerId);
end;

{-----------------------------------------------------------------------------}
Var LocSocket:word;

begin
LocSocket:=Socket;
readflg:=false;
if not IpxPresent
 then writeln('IPX Not Installed');
if not IpxOpenSocket(LocSocket,FALSE)
 then writeln('Error Opening Socket');
WhoAmI;
ProcessInputCommand;
end.